unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CommonMemory;

type
  TFrameForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    CM: TCommonMemory;
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

procedure TFrameForm.FormShow(Sender: TObject);
begin
  CM := TCommonMemory.Create('_comm8086_', 1024);
  Caption := IntToStr(CM.ProcessCount);
end;

procedure TFrameForm.Button1Click(Sender: TObject);
begin
  CM.Str := Edit1.Text;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  Edit2.Text := CM.Str;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CM.Free;
end;

procedure TFrameForm.Button3Click(Sender: TObject);
begin
  CM.StrList.Clear; // f[^[NA[B
  CM.StrList.Add(Edit1.Text);
  CM.StrList.Add(Edit2.Text);
  CM.Str := CM.StrList.Text; // Str  StrList ̃f[^Ă Memory ɃRs[B
  ShowMessage(CM.Str);
end;

procedure TFrameForm.Button4Click(Sender: TObject);
var
  i: Integer;
  S: String;
  Array1: array[0..3] of Integer;
  Array2: array[0..3] of Integer;
begin
  Array1[0] := 1234; Array1[1] := 5678;
  Array1[2] := 9012; Array1[3] := 3456;
  CopyMemory(CM.Memory, @Array1, SizeOf(Array1)); // z ===> L
  CopyMemory(@Array2, CM.Memory, SizeOf(Array2)); // L ===> z
  
  i := 0;
  repeat
    if Array2[i] <> Array1[i] then Break;
    Inc(i);
  until i = 4;

  S := IntToStr(Array2[0]) + ',  ' + IntToStr(Array2[1]) + ',  ' +
       IntToStr(Array2[2]) + ',  ' +IntToStr(Array2[3]);

  if i = 4 then
    ShowMessage('f[^͑SĈvĂ܂B' + #13#10 + #13#10 + S)
  else
    ShowMessage('f[^͈vĂ܂B' + #13#10 + S);

  Showmessage('CM[0] = ' + IntToStr(CM[0])); // CM[0] = CM.VInteger[0]
  CM[0] := 8086;
  Showmessage('CM[0] = ' + IntToStr(CM[0])); // CM[0] = CM.VInteger[0]
end;

end.

